/**
 * plugin.min.js
 *
 * Released under Attribution-ShareAlike 4.0 International License.
 * Authors: José Miguel Andonegi (http://www.ulhi.hezkuntza.net/web/guest/inicio1) and Ignacio Gros (http://gros.es/)
 *
 * License: http://creativecommons.org/licenses/by-sa/4.0/
 */

/**
 * To be used with "exeimage" and "exemedia"
 * It lets you align the blocks created with those plugins
 */
tinymce.PluginManager.add('exealign', function(editor, url) {
	
	function removeFloat(css) {
		css = css.split(";");
		var res = "";
		for (var i=0;i<css.length;i++) {
			if (css[i].indexOf("float:")==-1 && css[i].replace(/ /g,'')!="") {
				res += css[i]+";";
			}
		}
		return res;
	}
	
	function checkBlock(command){
	
		var ed = editor;
		var node = ed.selection.getNode();
		if (node.nodeName!="IMG" && node.className.indexOf('mce-preview-object ')!=0) return false;
		var c = jQuery(node);
		var e = c.parents();
		
		e.each(function(){
			
			if(this.className && this.className.indexOf("exe-figure")==0) {
			
				var currK = jQuery(this).attr("class");
				
				if (command=="JustifyLeft") {
					currK = currK.replace(" float-right","");					
					if (currK.indexOf(" position-right")!=-1) {
						currK = currK.replace(" position-right","");	
					} else if (currK.indexOf(" position-center")!=-1) {
						currK = currK.replace(" position-center","");
					} else {									
						if (currK.indexOf(" float-left")!=-1) {
							currK = currK.replace(" float-left","");
						} else {
							currK += " float-left";
						}
					}
				}
				
				else if (command=="JustifyCenter") {
					currK = currK.replace(" float-left","");
					currK = currK.replace(" float-right","");
					currK = currK.replace(" position-right","");
					if (currK.indexOf(" position-center")!=-1) {
						currK = currK.replace(" position-center","");
					} else {
						currK += " position-center";
					}
				}
				
				if (command=="JustifyRight") {
					currK = currK.replace(" position-center","");
					if (currK.indexOf(" float-left")!=-1) {
						currK = currK.replace(" float-left"," float-right");
					} else {					
						if (currK.indexOf(" position-right")!=-1) {
							currK = currK.replace(" float-right","");
							currK = currK.replace(" position-right"," float-right");
						} else {
							currK = currK.replace(" float-right","");
							currK += " position-right";
						}
					}
				}				

				this.className = currK;
				
				editor.dom.setAttrib(node, 'style', removeFloat(editor.dom.getAttrib(node, 'style')));
				
			}
		});
		
	}
	
    editor.on('ExecCommand', function(args) {
		var command = args['command'];
		if (command=="JustifyLeft" || command=="JustifyCenter" || command=="JustifyRight") {
			checkBlock(command);
		}
    });	
	
});